"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
// @ts-ignore
const xmlfmt = require("../packages/xml2js");
const ESCAPE_DOUBLE = /"([^"]*([&]+)[^"]*)"/g;
const ESCAPE_SINGLE = /'([^']*([&]+)[^']*)'/g;
const DESCAPE = /"@\[([^&]*)\]"/g;
const PARSER = new xmlfmt.Parser({ strict: true });
const BUILDER = new xmlfmt.Builder({});
function parseString(parser, text) {
    return __awaiter(this, void 0, void 0, function* () {
        return new Promise((resolve, reject) => {
            parser.parseString(text, (error, result) => {
                if (error) {
                    reject(error);
                }
                else {
                    resolve(result);
                }
            });
        });
    });
}
function formatXml(text) {
    return __awaiter(this, void 0, void 0, function* () {
        try {
            let formalText = text;
            formalText = text
                .replace(ESCAPE_DOUBLE, (_, matched) => {
                return `"@[${escape(matched)}]"`;
            })
                .replace(ESCAPE_SINGLE, (_, matched) => {
                return `"@[${escape(matched)}]"`;
            });
            const ast = yield parseString(PARSER, formalText);
            console.log("parsed.");
            console.log(ast);
            const result = BUILDER.buildObject(ast).replace(DESCAPE, (_, matched) => `"${unescape(matched)}"`);
            return result;
        }
        catch (error) {
            throw error;
        }
    });
}
exports.formatXml = formatXml;
//# sourceMappingURL=formatter.js.map